package com.sams.learnweblogic7.ejb.cmp;

import java.io.Serializable;
import java.util.Enumeration;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.NoSuchEntityException;
import javax.ejb.ObjectNotFoundException;
import javax.ejb.RemoveException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;


abstract public class ItemBean implements EntityBean {
    private EntityContext ctx;
  
	public void setEntityContext(EntityContext ctx) {
		System.out.println("setEntityContext called ");
		this.ctx = ctx;
	}

	public void unsetEntityContext() {
		System.out.println("ItemBean.unsetEntityContext");
		this.ctx = null;
	}

//abstract get and set methods necessary for all container managed fields
    abstract public int getItemId();
    abstract public void setItemId(int itemId);
	abstract public String getItemDesc();
    abstract public void setItemDesc(String itemDesc);
    abstract public String getItemIngredients();
    abstract public void setItemIngredients(String ingredients);
	abstract public String getItemTemperature();
	abstract public void setItemTemperature(String temperature);
	abstract public String getItemTaste();
	abstract public void setItemTaste(String taste);
	abstract public String getItemServingSize();
	abstract public void setItemServingSize(String servingSize);
	abstract public int getItemQuantity();
	abstract public void setItemQuantity(int quantity);
  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   */
  public void ejbActivate() {
      System.out.println("ItemBean.ejbActivate");
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   */
  public void ejbPassivate() {
    System.out.println("ItemBean.ejbPassivate");
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   */
  public void ejbLoad() {
    System.out.println("ItemBean.ejbLoad");
  }

  /**
   * Sets the EJBean's modified flag to false.
   * set to false to "reset" the variable for the next transaction.
   * 
   */
  public void ejbStore() {
    System.out.println("ItemBean.ejbStore");
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   * @exception               javax.ejb.RemoveException
   *                          if the EJBean does not allow removing the EJBean
   */
  public void ejbRemove()
    throws RemoveException
  {
    System.out.println("ItemBean.ejbRemove ");
  }

  /**
   * This method corresponds to the create method in the home interface
   * "ItemHome.java". 
   * The parameter sets of the two methods are identical.  When the client calls
   * <code>ItemHome.create()</code>, the container (which in WebLogic EJB is
   * also the home) allocates an instance of this EJBean and
   * calls <code>ItemHome.ejbCreate()</code>.
   * <p>
   * For container-managed persistence, <code>ejbCreate()</code> returns 
   * a null, unlike the case of bean-managed
   * persistence, where it returns a primary key.
   *
   * @param itemId				int itemId, 
   * @param temperature			String temperature
   * @param taste			    String taste
   * @param ingredients         String ingredients
   * @param servingSize			String servingSize
   * @exception               javax.ejb.CreateException
   *                          if there is a problem creating the bean
   */
  public ItemPK ejbCreate(int itemId, String temperature, String taste, String ingredients, String servingSize, int quantity) 
    throws CreateException
  {
    System.out.println("ItemBean.ejbCreate( id = " + System.identityHashCode(this) + 
				", PK = " +
				itemId + ", " + ", temperature = " + temperature + ", taste = "+taste+", ingredients="+ingredients+", serving size"+servingSize+")");

    setItemId(itemId);
    setItemTemperature(temperature);
    setItemTaste(taste);
	setItemIngredients(ingredients);
	setItemServingSize(servingSize);
	setItemQuantity(quantity);

    return null;  // See 9.4.2 of the EJB specification
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   *
   * @param itemId				int itemId, 
   * @param temperature			String temperature
   * @param taste			    String taste
   * @param ingredients         String ingredients
   */
  public void ejbPostCreate(int itemId, String temperature, String taste, String ingredients, String servingSize, int itemQuantity) 
  {
    System.out.println("ItemBean.ejbPostCreate (" + itemId() + ")");
  }

  /**
   * Returns the Primary Key identifying this EJBean.
   * 
   * @return                  int itemId
   */
  private String itemId() {
    return "" + System.identityHashCode(this) + ", PK = " + 
      (String) ((ctx == null) ? "nullctx" 
                 : ((ctx.getPrimaryKey() == null ?
                   "null" : ctx.getPrimaryKey().toString())));
  }

}