package com.sams.learnweblogic7.ejb.cmp;

import java.io.Serializable;
import java.util.Enumeration;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.NoSuchEntityException;
import javax.ejb.ObjectNotFoundException;
import javax.ejb.RemoveException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;


abstract public class ItemLogBean implements EntityBean {
    private EntityContext ctx;
  
	public void setEntityContext(EntityContext ctx) {
		System.out.println("setEntityContext called ");
		this.ctx = ctx;
	}

	public void unsetEntityContext() {
		System.out.println("ItemLogBean.unsetEntityContext");
		this.ctx = null;
	}

//abstract get and set methods necessary for all container managed fields
    abstract public int getItemId();
    abstract public void setItemId(int itemId);
	abstract public java.sql.Date getItemCreationDate();
    abstract public void setItemCreationDate(java.sql.Date itemCreationDate);
  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   */
  public void ejbActivate() {
      System.out.println("ItemLogBean.ejbActivate");
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   */
  public void ejbPassivate() {
    System.out.println("ItemLogBean.ejbPassivate");
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   */
  public void ejbLoad() {
    System.out.println("ItemLogBean.ejbLoad");
  }

  /**
   * Sets the EJBean's modified flag to false.
   * set to false to "reset" the variable for the next transaction.
   * 
   */
  public void ejbStore() {
    System.out.println("ItemLogBean.ejbStore");
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   * 
   * @exception               javax.ejb.RemoveException
   *                          if the EJBean does not allow removing the EJBean
   */
  public void ejbRemove()
    throws RemoveException
  {
    System.out.println("ItemLogBean.ejbRemove ");
  }

  /**
   * This method corresponds to the create method in the home interface
   * "ItemHome.java". 
   * The parameter sets of the two methods are identical.  When the client calls
   * <code>ItemHome.create()</code>, the container (which in WebLogic EJB is
   * also the home) allocates an instance of this EJBean and
   * calls <code>ItemHome.ejbCreate()</code>.
   * <p>
   * For container-managed persistence, <code>ejbCreate()</code> returns 
   * a null, unlike the case of bean-managed
   * persistence, where it returns a primary key.
   *
   * @param itemId				int itemId, 
   * @param temperature			String temperature
   * @param taste			    String taste
   * @param ingredients         String ingredients
   * @param servingSize			String servingSize
   * @exception               javax.ejb.CreateException
   *                          if there is a problem creating the bean
   */
  public ItemPK ejbCreate(int itemId, java.sql.Date itemCreationDate) 
    throws CreateException
  {
    System.out.println("ItemLogBean.ejbCreate called");
    setItemId(itemId);
    setItemCreationDate(itemCreationDate);

    return null;  // See 9.4.2 of the EJB specification
  }

  /**
   * This method is required by the EJB Specification,
   * but is not used by this example.
   *
   * @param itemId				int itemId, 
   * @param temperature			String temperature
   * @param taste			    String taste
   * @param ingredients         String ingredients
   */
  public void ejbPostCreate(int itemId, java.sql.Date itemCreationDate) 
  {
    System.out.println("ItemLogBean.ejbPostCreate (" + itemId() + ")");
  }

  /**
   * Returns the Primary Key identifying this EJBean.
   * 
   * @return                  int itemId
   */
  private String itemId() {
    return "" + System.identityHashCode(this) + ", PK = " + 
      (String) ((ctx == null) ? "nullctx" 
                 : ((ctx.getPrimaryKey() == null ?
                   "null" : ctx.getPrimaryKey().toString())));
  }

}